#include <iostream>
#include <limits.h> // La libreria che vi dicevo a lezione
using namespace std;
/*Definire una funzione che prende in input un array
monodimensionale di interi senza segno e inverte il valore massimo
con il valore minimo. ES: [ 1 2 6 4 5 ] ---> [ 6 2 1 4 5 ].*/

//Soluzione con puntatori
void inverterWithPointer(unsigned int a[], int n){
	/* Soluzione utilizzando i valori min e max del tipo con la libreria limits.h
	unsigned int MIN=UINT_MAX, MAX=0;  
	unsigned int* pMin=&MIN;
	unsigned int* pMax=&MAX;*/
	
	//Qui faccio puntare entrambi i puntatori al primo elemento dello array
	unsigned int* pMin=a;
	unsigned int* pMax=a;
	
	
	for (int i=0; i<n; i++){
		if(a[i]<*pMin)
			pMin=&a[i];
		if(a[i]>*pMax)
			pMax=&a[i];
	}
	cout<<"Min value "<<*pMin<<endl;
	cout<<"Max value "<<*pMax<<endl;
	//swap
	unsigned int tmp=*pMin;
	*pMin=*pMax;
	*pMax=tmp;
}

//Soluzione senza puntatori
void inverterWithoutPointer(unsigned int a[], int n){
	unsigned int MIN=UINT_MAX, MAX=0;
	int m, M=-1;
	
	for (int i=0; i<n; i++){
		if (a[i]<MIN){
			MIN=a[i];
			m=i;
		}
		if(a[i]>MAX){
			MAX=a[i];
			M=i;
		}
	}
	unsigned int tmp=a[m];
	a[m]=a[M];
	a[M]=tmp;
}


int main(){
	
	unsigned int a[5]={1,2,6,4,5};
	cout<<"Stampo lo array prima dell'inversione Min -> Max"<<endl;
	for (int i=0; i<5; i++)
		cout<<a[i]<<" ";
	printf("\n");
	
	inverterWithPointer(a,5);
	//inverterWithoutPointer(a,5);
	
	cout<<"Stampo lo array con Min - > Max invertiti"<<endl;
	
	for (int i=0; i<5; i++)
		cout<<a[i]<<" ";
	return 0;
}
